﻿using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XNEPromptChar
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }


        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.xdg1.DataSource = (this.DataContext as ViewModel).Data;

            FieldLayout fl = new FieldLayout();

            fl.Fields.Add(new Field("Make"));
            fl.Fields.Add(new Field("Model"));

            NumericField priceField = new NumericField();
            priceField.Name = "Price";

            NumericField mileageField = new NumericField();
            priceField.Name = "Mileage";
            priceField.TrimFractionalZeros = true;
            priceField.SpinButtonDisplayMode = SpinButtonDisplayMode.Always;
            priceField.SpinIncrement = 1;
            priceField.Format = "0.###";

            Style numericEditorStyle = new Style(typeof(XamNumericEditor));
            numericEditorStyle.Setters.Add(new Setter(XamNumericEditor.PromptCharProperty, ""));

            FieldSettings pfFieldSettings = new FieldSettings();
            pfFieldSettings.EditAsType = typeof(Double);

            // First option - assign the programmatically created style
            pfFieldSettings.EditorStyle = numericEditorStyle;

            // Second option - style is defined in xaml, in the grid's resouces, assign it here
            //pfFieldSettings.EditorStyle = this.xdg1.Resources["XNEStyle"] as Style;

            priceField.Settings = pfFieldSettings;

            fl.Fields.Add(priceField);
            fl.Fields.Add(mileageField);

            this.xdg1.FieldLayouts.Add(fl);
           
        }
    }
}
