﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XNEPromptChar
{
    public class ViewModel
    {
        private ObservableCollection<DataModel> _data { get; set; }
        public ObservableCollection<DataModel> Data
        {
            get
            {
                return _data;
            }
            set
            {
                if (_data != value)
                {
                    _data = value;
                    NotifyPropertyChanged("Data");
                }
            }
        }

        public ViewModel()
        {
            this._data = new ObservableCollection<DataModel>();
            this._data.Add(new DataModel() { Make = "Ford", Model = "Mustang", Price = 25000.669, Mileage = 1000 });
            this._data.Add(new DataModel() { Make = "Jeep", Model = "Wrangler", Price = 21000.66, Mileage = 200 });
            this._data.Add(new DataModel() { Make = "Honda", Model = "Accord", Price = 19500.78, Mileage = 1000 });
            this._data.Add(new DataModel() { Make = "Toyota", Model = "Camry", Price = 22500.66, Mileage = 500 });
            this._data.Add(new DataModel() { Make = "Ford", Model = "Escort", Price = 15000.66, Mileage = 15000 });
            this._data.Add(new DataModel() { Make = "Toyota", Model = "4Runner", Price = 33000.66, Mileage = 50 });
            this._data.Add(new DataModel() { Make = "Honda", Model = "Pilot", Price = 35000, Mileage = 18000 });
            this._data.Add(new DataModel() { Make = "Jeep", Model = "Patriot", Price = 22000, Mileage = 1000 });
            this._data.Add(new DataModel() { Make = "Honda", Model = "Civic", Price = 19500, Mileage = 30000 });
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }

    public class DataModel : INotifyPropertyChanged
    {
        private string _make;
        public string Make
        {
            get
            {
                return _make;
            }
            set
            {
                if (_make != value)
                {
                    _make = value;
                    NotifyPropertyChanged("Make");
                }
            }
        }

        private string _model;
        public string Model
        {
            get
            {
                return _model;
            }
            set
            {
                if (_model != value)
                {
                    _model = value;
                    NotifyPropertyChanged("Model");
                }
            }
        }

        private double _price;
        public double Price
        {
            get
            {
                return _price;
            }
            set
            {
                if (_price != value)
                {
                    _price = value;
                    NotifyPropertyChanged("Price");
                }
            }
        }

        private int _mileage;

        public DataModel(string make, string model, int price, int mileage)
        {
            Make = make;         
            Model = model;
            Price = price;
            Mileage = mileage;
        }

        public DataModel()
        {
        }

        public int Mileage
        {
            get
            {
                return _mileage;
            }
            set
            {
                if (_mileage != value)
                {
                    _mileage = value;
                    NotifyPropertyChanged("Mileage");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
